#include <stdio.h>
#include <iostream>
#include <string>
#include "kilavuz.h"
#include "stack.h"
using namespace std;

#define TRESHOLD  1

int min(int a, int b, int c)
{
	if(a > b){a=b;}
	if(a > c){a=c;}
	return a;
}

#define min2(x,y) x<y?x:y
#define max(x,y) x>y?x:y

/* Hata toleransli algoritma'nin bir parcasi, 
 * duzenleme uzakligini hesapliyor
 */

int edit_distance (string a, string b)
{
	if(a.length() == 0)
	{
		return b.length();
	}
	if(b.length() == 0)
	{
		return a.length();
	}
	string c,d;
	int an = ( a.length() - 1);
	int bn = ( b.length() - 1);
	if(a[an] == b[bn])
	{ 
		return  edit_distance( a.substr(0, (a.length() -1)) , b.substr(0, (b.length() -1)) );
	}

	if(a[an-1] == b[bn] && b[bn-1] == a[an])
	{
		return 1 + min( edit_distance ( a.substr ( 0 , (a.length() -2)) , b.substr(0,(b.length() -2))),edit_distance(a, b.substr(0,(b.length() -1))), edit_distance(a.substr(0,(a.length() -1)), b));
	}

	else
	{
		return 1 + min(edit_distance(a.substr(0,(a.length() -1)),b.substr(0,(b.length() -1))),edit_distance(a, b.substr(0,(b.length() -1))), edit_distance(a.substr(0,(a.length() -1)), b));
	}
}

int cuted (string a, string b)
{
	int temp;
	int h = 99; // Yuksek bir sayi ihtiyacindan dolayi
	int l = min2(1, b.length() - TRESHOLD);
	int u = max(a.length() , b.length() + TRESHOLD);
	for( ; u >= l ; u--)
		{
			temp = edit_distance(a.substr(0, u), b);
			if(temp < h)
			{
				h = temp;
			}
		}
	return h;
}


Node::Node()
{
	mynode = NULL;
	isFinal = 0;
	int numPaths = 0;
}


void Node::addIsFinal(int num)
{
	isFinal = num;
}

bool Node::returnIsFinal()
{
	if (isFinal == 0)
	{
		return false;
	}
	return true;
}

listNode * Node ::returnMyNode()
{
	return mynode;
}

int Node::returnNumPaths()
{
	return numPaths;
}

void Node::AddPath(char ch, int num)
{

	listNode * header = mynode;
	if(mynode == NULL)
	{
		mynode = new listNode;
		mynode->ch = ch;
		mynode->numWhere = num;
		mynode->next = NULL;
		return;
	}
	while (header->next != NULL )
	{
		header = header->next;
	}
	header->next = new listNode;
	header = header->next;
	header->ch = ch;
	header->numWhere = num;
	header->next = NULL;

	numPaths += 1;
}

int Node::NodeSearch(char ch)
{
	listNode *header = mynode;
	if ( header == NULL)
	{
		return -1;
	}
	while (header->ch != ch && header->next != NULL)
	{
		header = header->next;
	}
	if(header->ch == ch)
		return header->numWhere;
	else if (header->next == NULL)
		return -1;
	else 
		return -1;
}

Lexicon::Lexicon()
{
	for(int i=0;i<30887;i++)
	{
		myvector[i] = new Node();
	}

}
void Lexicon::I(int which, int finalorNot)
{
	myvector[which]->addIsFinal(finalorNot);
}
void Lexicon::P(int where, char ch, int path)
{
	myvector[where]->AddPath(ch,path);
}
bool Lexicon::Search(string st_search)
{
	int size = st_search.size();
	if (size < 1)
	{
		return true;
	}

	int i= 0;

	int result = myvector[1]->NodeSearch( st_search[i]);
	i++;
	while (result != -1 && i<size)
	{
		
		result = myvector[result]->NodeSearch(st_search[i]);
		i++;
	}
	if(result == -1)
	{
		return false;
	}

	return myvector[result]->returnIsFinal();
}

string reverse(string a)
{
for(int c=0;c<a.length();c++)
{
 if(a[c]=='C') a[c]='';
 if(a[c]=='O') a[c]='';
 if(a[c]=='U') a[c]='';
 if(a[c]=='G') a[c]='';
 if(a[c]=='I') a[c]='';
 if(a[c]=='S') a[c]='';
}
return a;
}      

void Lexicon::find_alternatives(string & str_errored)
{
	int i = 0;
	Stack thestack;
	string deneme;
	int yeter;
	struct_Node temp;
	listNode * ll_searcher;
	thestack.Push(deneme,1);
 
	while(!thestack.Empty())
	{
		temp = thestack.Pop();
		yeter = temp.int_qi;
		ll_searcher = myvector[yeter]->returnMyNode();
		while ( ll_searcher != NULL)
		{
			yeter = ll_searcher->numWhere;
			deneme= temp.str_word;
			deneme += ll_searcher->ch;
			if  ( cuted(str_errored,deneme) <= 1)
			{
				thestack.Push(deneme,ll_searcher->numWhere);
				if( (edit_distance(str_errored,deneme) <= 1 )&& (myvector[yeter]->returnIsFinal() == true) )
				{
					cout << reverse(deneme) <<endl;
					i++;
				}
			}
			ll_searcher = ll_searcher->next;
		}
	}
	cout <<i<<" Alternatif Bulundu."<<endl;
}
extern void buildAll(Lexicon & A);
void print_menu()
{
	system("clear"); 
	cout << "Klavuz Yardm Mns\n\n------------------------------------\n\nkmak iin '*' giriniz \nBu menu iin 'H' giriniz \n\nTrke karakter kullanamyorsanz \n\n'' yerine 'U'\n'' yerine 'C'\n'' yerine 'S'\n'' yerine 'I'\n'' yerine 'G'\n'' yerine 'O'\n\nkullanabilirsiniz.\n\n------------------------------------\n\nM. Emrah Parlakay - Hseyin Ergn\n\n";
}

string translate(string a)
{
for(int c=0;c<a.length();c++)
{
 if(a[c]=='') a[c]='C';
 if(a[c]=='') a[c]='O';
 if(a[c]=='') a[c]='U';
 if(a[c]=='') a[c]='G';
 if(a[c]=='') a[c]='I';
 if(a[c]=='') a[c]='S';
}
return a;
}

int main()
{
	Lexicon A;
	buildAll(A);
	string temp;

	system("clear"); 
	cout <<"Klavuz 0.1b\nTrke mla Denetim Program \n\n------------------------------------\nkmak iin '*', yardm iin 'H' giriniz.)\nLtfen kk harf kullannz.\n------------------------------------\n\nBir kelime giriniz : ";
	 cin >> temp;
	 while (temp != "*")
	 {
		 if(temp == "H")
		 {
			 print_menu();
		 }
		 else
		 {
		 	temp = translate(temp);
	 		if(A.Search(temp))
	 		{
	      			cout << "\n" << reverse(temp) << " Doru" << endl;
	 		}
		 	else
	 		{
              			cout <<"\n"<< reverse(temp) << " Doru deil, alternatif kelimeler ..."<<endl;
	      			A.find_alternatives(temp);
         		}
		 }
	     	cout <<"\nBir kelime giriniz : " ;
		 cin >> temp;
	 }
       return 0;
}

